SystemOrganization addCategory: #SistemaWeb!

WAComponent subclass: #LoginComponent
	instanceVariableNames: 'name password user warning'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SistemaWeb'!

!LoginComponent methodsFor: 'rendering' stamp: 'FA 6/29/2013 23:00'!
renderContentOn: html
	html div 
		class: 'login-container';
		with: [
			
			html heading: warning.  
			html form: [
				html textInput
					text: 'name' ;
					callback: [ :value | name := value ].
				html passwordInput
					text: 'password' ;  
					callback: [ :value | password := value ].  
				html submitButton
					text: 'Login';
					callback: [   user:=(UserManager singleton) login: { name . password }.
								user ifNil: [	warning :=	'Incorrect login.' ];
									  ifNotNil: [ warning := 'Welcome, ', (user username). ].    
				 			 ].  
			].
		]
! !

WAComponent subclass: #MainComponent
	instanceVariableNames: 'login'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SistemaWeb'!

!MainComponent class methodsFor: 'class initialization' stamp: 'HGPL 6/29/2013 21:22'!
initialize
	WAAdmin register: self asApplicationAt: 'poo'! !

!MainComponent methodsFor: 'initialization' stamp: 'HGPL 6/29/2013 21:26'!
initialize
	super initialize.
	login := LoginComponent new! !

!MainComponent methodsFor: 'convenience' stamp: 'tgn 6/30/2013 12:49'!
isLogged
	^ (UserManager singleton) loggedUser size == 0! !

!MainComponent methodsFor: 'rendering' stamp: 'tgn 6/30/2013 12:48'!
renderContentOn: html
	(html div)
		class: 'header';
		with: [ login renderContentOn: html ].
	html horizontalRule.
	self isLogged
		ifFalse: [ 
			(html anchor)
				callback: [ self call: SignUpComponent new ];
				with: 'Sign Up' ].! !

!MainComponent methodsFor: 'rendering' stamp: 'FA 6/30/2013 11:57'!
style ^ 'div.header {
   height: 30px;
}

div.login-container {
   width: 350px;
   float: right;
   display: block;
}'! !

WAComponent subclass: #NewTopicComponent
	instanceVariableNames: 'name warning description moderators'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SistemaWeb'!

!NewTopicComponent methodsFor: 'rendering' stamp: 'FA 6/30/2013 13:08'!
initialize
	super initialize.
	user := nil.! !

!NewTopicComponent methodsFor: 'rendering' stamp: 'FA 6/30/2013 13:37'!
renderContentOn: html
	html heading: warning.
	html
		form: [ 
			html text: 'Name:'.
			html textInput callback: [ :value | name := value ].
			html break.
			html text: 'Description'.
			html textInput callback: [ :value | description := value ].
			html break.
			html text: 'Moderators'.
			html textInput callback: [ :value | moderators := value ].
			html break.
			html submitButton
				callback: [ warning := 'TODO: criar Programa e adicionar no banco'. ] .
				].
			! !

WAComponent subclass: #SignUpComponent
	instanceVariableNames: 'name email password user warning'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SistemaWeb'!

!SignUpComponent methodsFor: 'rendering' stamp: 'FA 6/29/2013 22:16'!
initialize
	super initialize.
	user := nil.! !

!SignUpComponent methodsFor: 'rendering' stamp: 'tgn 6/30/2013 12:52'!
renderContentOn: html
	html heading: warning.
	html
		form: [ 
			html text: 'Name:'.
			html textInput callback: [ :value | name := value ].
			html break.
			html text: 'Email:'.
			html textInput callback: [ :value | email := value ].
			html break.
			html text: 'Password:'.
			html passwordInput callback: [ :value | password := value ].
			html break.
			html submitButton
				callback: [ 
					user := UserManager singleton
						register:
							(Dictionary
								newFrom:
									{('username' -> name).
									('password' -> password).
									('email' -> email)}).
					user
						ifNil: [ warning := 'Sorry, user already exists.' ];
						ifNotNil: [ self answer ] ] ]! !
MainComponent initialize!
